<?php

define('IN_MY', true);

// HERE
define('HERE', str_replace('\\', '/', dirname(__FILE__)) . '/');
define('INC', HERE . 'inc/');
define('DATA', HERE . 'data/');

// Load cfg
require_once(DATA . 'config.php');

// Load DB
require_once(DATA . 'dbconfig.php');
require_once(INC . 'mysql.php');
$DB = new MySQL();
$DB->server = DBHOST;
$DB->user = DBUSER;
$DB->password = DBPASS;
$DB->database = DBNAME;
$DB->connect();

$TheIP = $_SERVER['REMOTE_ADDR'];
$TheID = $_GET['id'];

// Check IP on DB, if not exist will generate new id
$IPInfo = $DB->query_fecth(sprintf('SELECT * FROM links WHERE ip = %s;', SQLSave($TheIP, 'text')));
if($IPInfo)
{
	$HitNum = $IPInfo->hit;
	$IpId = $IPInfo->id;
}
else
{
	// Generate rand id and make sure it not duplicate
	$RandLength = 30;
	do {
		$RwV = array();
		$RwV = array_merge($RwV, range(0, 9));
		$RwV = array_merge($RwV, range('a', 'z'));
		srand((float)microtime() * 1000000);
		shuffle($RwV);
		$rv = '';
		
		for($i=0;$i<$RandLength;$i++)
		{
			srand((float)microtime() * 10000000);
			$ar = array_rand($RwV, 1);
			$rv .= $RwV[$ar];
		}
		
		$CheckGId = $DB->query_fecth(sprintf('SELECT * FROM links WHERE id = %s;', SQLSave($rv, 'text')));
		$CheckGId = $CheckGId ? true:false;
	} while ($CheckGId);
	
	$DB->query(sprintf('INSERT INTO links (id,ip,hit) VALUES (%s,%s,0);',
		SQLSave($rv, 'text'),
		SQLSave($TheIP, 'text')
	));
	
	$HitNum = 0;
	$IpId = $rv;
}

// Log Hit
if($TheID && $TheID !== $IpId)
{
	// Check the hit already logged or not
	$RefInf = $DB->query_fecth(sprintf('SELECT whohit FROM links WHERE id = %s;', SQLSave($TheID, 'text')));
	if($RefInf)
	{
		$LogHit = false;
		if($RefInf->whohit)
		{
			$wh = explode("|", $RefInf->whohit);
			if(!in_array($TheIP, $wh))
			{
				$LogHit = true;
				$NewWhoHit = $RefInf->whohit.'|'.$TheIP;
			}
		}
		else
		{
			$LogHit = true;
			$NewWhoHit = $TheIP;
		}
		
		if($LogHit === true)
		{
			$DB->query(sprintf('UPDATE links SET hit = hit+1, whohit = %s WHERE id = %s;',
				SQLSave($NewWhoHit, 'text'),
				SQLSave($TheID, 'text')
			));
		}
	}
}

// Getting visitor country code
$VisitorCountry = NULL;
include_once(INC . 'geoip/geoip.php');
$gi = geoip_open(INC . 'geoip/GeoIP.dat', GEOIP_STANDARD);
$VisitorCountry = geoip_country_code_by_addr($gi, $TheIP);

$ImgVidCols = (int)$config['imgcols'];
$ImgVidCols = $ImgVidCols == 0 ? 1:$ImgVidCols;
$HitRule = '';
$ZeroImg = '';
$RevImg = '';
$ImgRule = unserialize($config['imagerule']);
$TheImg = unserialize($config['images']);
if(count($ImgRule) > 0)
{
	ksort($ImgRule);
	$TheImgCount = count($TheImg);
	if($TheImgCount > 0)
	{
		$RevImgNum = 0;
		$ZeroImgNum = $ImgRule[0] ? $ImgRule[0]:0;
		foreach($ImgRule as $h => $v)
		{
			if($h <= $HitNum)
			{
				$RevImgNum = $v;
			}
		}
		
		$NoZeroImgNum = $TheImgCount-$ZeroImgNum;
		if($ZeroImgNum > 0)
		{
			$ZIi = 0;$ZIc = 0;$ZIcn = 0;
			$ZINcc = $ZeroImgNum;
			$ZeroImg .= '<table><tbody><tr>';
		}
		if($NoZeroImgNum > 0)
		{
			$NZIi = 0;$NZIc = 0;$NZIcn = 0;
			$NZINcc = $NoZeroImgNum;
			$RevImg .= '<table><tbody><tr>';
		}
		foreach($TheImg as $v)
		{
			if($RevImgNum > 0)
			{
				$ihtml = ''.$v['image'].$v['thumb'].'';
				$RevImgNum--;
			}
			else
			{
				$ihtml = '<img src="'.$config['hiddenimg'].'" alt="Hidden" />';
			}
			if($ZINcc > 0)
			{
				if($ZIc == $ImgVidCols)
				{
					$ZeroImg .= '</tr><tr>';
					$ZIc = 0;
					$ZIcn++;
				}
				$ZIc++;
				$ZeroImg .= '<td'.($ZINcc == 1 && $ZIc == 1 ? ' colspan="'.$ImgVidCols.'"':'').'>'.$ihtml.'</td>';
				$ZIi++;$ZINcc--;
			}
			else
			{
				if($NZIc == $ImgVidCols)
				{
					$RevImg .= '</tr><tr>';
					$NZIc = 0;
					$NZIcn++;
				}
				$NZIc++;
				$RevImg .= '<td'.($NZINcc == 1 && $NZIc == 1 ? ' colspan="'.$ImgVidCols.'"':'').'>'.$ihtml.'</td>';
				$NZIi++;$NZINcc--;
			}
		}
		if($ZeroImgNum > 0)
		{
			$ZiRem = $ImgVidCols-$ZIc;
			if($ZIc > 1 && $ZIcn > 0)
			{
				for($i=0;$i<$ZiRem;$i++)
				{
					$ZeroImg .= '<td></td>';
				}
			}
			$ZeroImg .= '</tr></table>';
		}
		if($NoZeroImgNum > 0)
		{
			$NZiRem = $ImgVidCols-$NZIc;
			if($NZIc > 1 && $NZIcn > 0)
			{
				for($i=0;$i<$NZiRem;$i++)
				{
					$RevImg .= '<td></tbody></td>';
				}
			}
			$RevImg .= '</tr></tbody></table>';
		}
	}
	
	unset($ImgRule[0]);
	$HtRlCl = 'even';
	if(count($ImgRule) > 0)
	{
		foreach($ImgRule as $h => $v)
		{
			$HitRule .= '<tr class="'.$HtRlCl.'"><td>'.$h.'</td><td>'.$v.'</td></tr>';
			$HtRlCl = $HtRlCl == 'even' ? 'odd':'even';
		}
	}
}

$ZeroVid = '';
$RevVid = '';
$VidRule = unserialize($config['videorule']);
$TheVid = unserialize($config['videos']);
if(count($VidRule) > 0)
{
	ksort($VidRule);
	$TheVidCount = count($TheVid);
	if($TheVidCount > 0)
	{
		$RevVidNum = 0;
		$ZeroVidNum = $VidRule[0] ? $VidRule[0]:0;
		foreach($VidRule as $h => $v)
		{
			if($h <= $HitNum)
			{
				$RevVidNum = $v;
			}
		}
		
		$NoZeroVidNum = $TheVidCount-$ZeroVidNum;
		if($ZeroVidNum > 0)
		{
			$ZIi = 0;$ZIc = 0;$ZIcn = 0;
			$ZINcc = $ZeroVidNum;
			$ZeroVid .= '<table><tbody><tr>';
		}
		if($NoZeroVidNum > 0)
		{
			$NZIi = 0;$NZIc = 0;$NZIcn = 0;
			$NZINcc = $NoZeroVidNum;
			$RevVid .= '<table><tbody><tr>';
		}
		foreach($TheVid as $v)
		{
			if($RevVidNum > 0)
			{
				$ihtml = $v;
				$RevVidNum--;
			}
			else
			{
				$ihtml = '<img src="'.$config['hiddenimg'].'" alt="Hidden" />';
			}
			if($ZINcc > 0)
			{
				if($ZIc == $ImgVidCols)
				{
					$ZeroVid .= '</tr><tr>';
					$ZIc = 0;
					$ZIcn++;
				}
				$ZIc++;
				$ZeroVid .= '<td'.($ZINcc == 1 && $ZIc == 1 ? ' colspan="'.$ImgVidCols.'"':'').'>'.$ihtml.'</td>';
				$ZIi++;$ZINcc--;
			}
			else
			{
				if($NZIc == $ImgVidCols)
				{
					$RevVid .= '</tr><tr>';
					$NZIc = 0;
					$NZIcn++;
				}
				$NZIc++;
				$RevVid .= '<td'.($NZINcc == 1 && $NZIc == 1 ? ' colspan="'.$ImgVidCols.'"':'').'>'.$ihtml.'</td>';
				$NZIi++;$NZINcc--;
			}
		}
		if($ZeroVidNum > 0)
		{
			$ZiRem = $ImgVidCols-$ZIc;
			if($ZIc > 1 && $ZIcn > 0)
			{
				for($i=0;$i<$ZiRem;$i++)
				{
					$ZeroVid .= '<td></td>';
				}
			}
			$ZeroVid .= '</tr></tbody></table>';
		}
		if($NoZeroVidNum > 0)
		{
			$NZiRem = $ImgVidCols-$NZIc;
			if($NZIc > 1 && $NZIcn > 0)
			{
				for($i=0;$i<$NZiRem;$i++)
				{
					$RevVid .= '<td></td>';
				}
			}
			$RevVid .= '</tr></tbody></table>';
		}
	}
	
	unset($VidRule[0]);
	$VidRllC = count($VidRule);
	if($VidRllC > 0)
	{
		foreach($VidRule as $h => $v)
		{
			if($VidRllC > 1)
				$HitRule .= '<tr class="'.$HtRlCl.'"><td>'.$h.'</td><td>'.$v.' SECRET VIDEOS</td></tr>';
			else
				$HitRule .= '<tr class="'.$HtRlCl.'"><td>'.$h.'</td><td>SECRET VIDEO</td></tr>';
			
			$HtRlCl = $HtRlCl == 'even' ? 'odd':'even';
		}
	}
}
if($HitRule)
{
	$HitRule = '<table><thead><tr><th>Number of clicks</th><th>Number of Freebies</th></tr></thead><tbody>'.$HitRule.'</tbody></table>';
}




$SiteContent = $config['sitetemplate'];
$SFind = array("{hitrule}", "{refurl}", "{hitnum}", "{zeroimg}", "{zerovid}", "{revimg}", "{revvid}");
$SReplace = array(
	$HitRule,
	$config['http_home_url'].'?id='.$IpId,
	$HitNum,
	$ZeroImg,
	$ZeroVid,
	$RevImg,
	$RevVid
);
$SiteContent = str_replace($SFind, $SReplace, $SiteContent);

if($VisitorCountry == 'US')
{
	$SiteContent = preg_replace('%\[us_visitor\](.*?)\[/us_visitor\]%si', '\1', $SiteContent);
	$SiteContent = preg_replace('%\[intl_visitor\](.*?)\[/intl_visitor\]%si', '', $SiteContent);
}
else
{
	$SiteContent = preg_replace('%\[us_visitor\](.*?)\[/us_visitor\]%si', '', $SiteContent);
	$SiteContent = preg_replace('%\[intl_visitor\](.*?)\[/intl_visitor\]%si', '\1', $SiteContent);
}

?>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title><?=$config['description'];?></title>
<meta name="description" content="<?=$config['description'];?>" />
<meta name="keywords" content="<?=$config['keywords'];?>" />
<meta name="robots" content="index,follow" />
<style type="text/css">
<!--
<?=$config['sitecss'];?>

</style>
</head>

<body>
<?=$SiteContent;?>
</body>
</html>